﻿/*
 * ******************************************************************
 * Springcard - CsbApduScriptor
 * Scripting application using SpringProx API
 * Copyright (c) 2004-2014 Pro Active SAS, France
 * Go to www.springcard.com for information and updates
 * ******************************************************************
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using SpringProxAPI;

namespace CsbApduScriptor
{
	/// <summary>
	/// Description of ReaderInformation.
	/// </summary>
	public partial class ReaderInformation : Form
	{
		/// <summary>
		/// COM Port used by the reader
		/// </summary>
		/// <param name="ComPort"></param>
		public ReaderInformation(string ComPort)
		{
			InitializeComponent();
			Cursor.Current = Cursors.WaitCursor;
			uint features = 0;

			byte[]rc500_type = new byte[5];
			byte[]rc500_id = new byte[4];
			short rc;

			
			eLibrary.Text = SPROX.GetLibrary();
			eFirmware.Text = SPROX.ReaderGetFirmware();
			eDevice.Text = SPROX.ReaderGetDevice();
			rc = SPROX.ReaderGetRc500Id(rc500_type, rc500_id);
			if (rc == SPROX.MI_OK)
			{
				eRcType.Text =
					String.Format("{0:X02}{1:X02}{2:X02}{3:X02}{4:X02}",
					              rc500_type[0], rc500_type[1], rc500_type[2],
					              rc500_type[3], rc500_type[4]);
				eRcId.Text =
					String.Format("{0:X02}{1:X02}{2:X02}{3:X02}", rc500_id[0],
					              rc500_id[1], rc500_id[2], rc500_id[3]);
			}

			rc = SPROX.ReaderGetFeatures(ref features);
			if (rc == SPROX.MI_OK)
			{
				eFeatures.Text = String.Format("{0:X08}", features);
			}
			Cursor.Current = Cursors.Default;
			
		}
		
		void BtnCloseClick(object sender, EventArgs e)
		{
			Close();
		}
		
		void BtnRfOnClick(object sender, EventArgs e)
		{
			Cursor.Current = Cursors.WaitCursor;
			short rc = SPROX.ControlRF(1);
			Cursor.Current = Cursors.Default;
		}
		
		void BtnRfOffClick(object sender, EventArgs e)
		{
			Cursor.Current = Cursors.WaitCursor;
			short rc = SPROX.ControlRF(0);
			Cursor.Current = Cursors.Default;
		}
	}
}
